MODULE Accent;
(* $L-, $R-, $T-, $S- *)
FROM SYSTEM IMPORT BYTE;
FROM System IMPORT GetArg,Terminate;
FROM InOut IMPORT Read,Write;
FROM ASCII IMPORT EOF,EOL,CR,LF;
FROM TermOut IMPORT WriteString,WriteLn,handle;
(*
FROM DumpOut IMPORT Print,PrintHex,PrintString,PrintLn,PrintCard,IOHandle;
*)
TYPE
	CodeType = ARRAY [1..32] OF CHAR;
VAR ch,cp : CHAR;
		c : CARDINAL;
		direction : BOOLEAN;
		Ascii,ANSI :CodeType;
PROCEDURE Usage ();
BEGIN
	handle := 2;
	WriteString ('Usage:  filter accent');WriteLn;
	WriteString ('> accent [/direction] <input > output ');WriteLn;
	WriteString (' /direction N,n --> ASCII to ANSI conversion');WriteLn;
	WriteString ('  default          ANSI to ASCII conversion');WriteLn;
	WriteString (' Windows use ANSI and DOS use ASCII ');WriteLn;
	Terminate (0);
END Usage;
PROCEDURE Scan ();
BEGIN
  	c := 32;
  	LOOP
  		IF direction THEN
  			IF ch = Ascii[c] THEN EXIT END
  		ELSE
  			IF ch = ANSI[c] THEN EXIT END
  		END;(*IF*)
  		DEC (c);
  		IF c = 0 THEN EXIT END;
  	END;(*LOOP*)
END Scan;
(* $L- *)
BEGIN
(*IOHandle := 3;*)
	LOOP
  	GetArg (Ascii,c);
(*PrintString (Ascii);PrintCard (c,4);PrintLn;*)
  	IF c = 0 THEN EXIT END;
  	ch := Ascii[1];
  	IF (ch = '/') OR (ch = '[') THEN
  		ch := Ascii[2];
  		IF (ch = 'N') OR (ch = 'n') THEN
  			direction := TRUE
  		ELSIF (ch = '?') OR (ch = 'H') OR (ch = 'h') THEN
  			Usage ();
  		ELSE
  			direction := FALSE
  		END;(*IF*)
  	ELSIF ch = '?' THEN
  		Usage ();
  	END;(*IF*)
	END;(*LOOP*)
	cp := ' ';
  Ascii[1] := 80X;ANSI[1] := 0C7X;
  Ascii[2] := 81X;ANSI[2] := 0FCX;
  Ascii[3] := 82X;ANSI[3] := 0E9X;
  Ascii[4] := 83X;ANSI[4] := 0E2X;
  Ascii[5] := 84X;ANSI[5] := 0E4X;
  Ascii[6] := 85X;ANSI[6] := 0E0X;
  Ascii[7] := 86X;ANSI[7] := 0E5X;
  Ascii[8] := 87X;ANSI[8] := 0E7X;
  Ascii[9] := 88X;ANSI[9] := 0EAX;
  Ascii[10] := 89X;ANSI[10] := 0EBX;
  Ascii[11] := 8AX;ANSI[11] := 0E8X;
  Ascii[12] := 8BX;ANSI[12] := 0EFX;
  Ascii[13] := 8CX;ANSI[13] := 0EEX;
  Ascii[14] := 8DX;ANSI[14] := 0ECX;
  Ascii[15] := 8EX;ANSI[15] := 0C4X;
  Ascii[16] := 8FX;ANSI[16] := 0C5X;
  Ascii[17] := 90X;ANSI[17] := 0C8X;
  Ascii[18] := 93X;ANSI[18] := 0F4X;
  Ascii[19] := 94X;ANSI[19] := 0F6X;
  Ascii[20] := 95X;ANSI[20] := 0F2X;
  Ascii[21] := 96X;ANSI[21] := 0FBX;
  Ascii[22] := 97X;ANSI[22] := 0F9X;
  Ascii[23] := 98X;ANSI[23] := 0FFX;
  Ascii[24] := 99X;ANSI[24] := 0D6X;
  Ascii[25] := 9AX;ANSI[25] := 0DCX;
  Ascii[26] := 0A0X;ANSI[26] := 0E1X;
  Ascii[27] := 0A1X;ANSI[27] := 0EDX;
  Ascii[28] := 0A2X;ANSI[28] := 0F3X;
  Ascii[29] := 0A3X;ANSI[29] := 0FAX;
  Ascii[30] := 0A4X;ANSI[30] := 0F1X;
  Ascii[31] := 0A5X;ANSI[31] := 0D1X;
  Ascii[32] := 0A8X;ANSI[32] := 0BFX;
  REPEAT
  	Read (ch);
(*Print (ch);PrintHex (ORD (ch),2);*)
  	Scan ();
  	IF c > 0 THEN
(*PrintCard (c,2);*)
  		IF direction THEN
  			ch := ANSI[c]
  		ELSE
  			ch := Ascii[c]
  		END;(*IF*)
(*Print (ch);PrintHex (ORD (ch),2);*)
  	END;
 		IF (cp = CR) OR (cp = EOL) THEN
	 		IF (ch <> LF) THEN
	 			Write (ch)
(*ELSE
PrintString ('skipped LF');*)
	 		END
		ELSE
	 		Write (ch)
 		END;(* Write in FST M-2 appends LF after EOL*)
(*PrintLn;*)
 		cp := ch;
  UNTIL ch = EOF;
END Accent.
